<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Report_views_monthly_model extends CI_Model
{
    protected $_table = 'report_views_monthly_new';

    public function __construct(){
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
    }

    public function cmsCountAll($name = null)
    {
        $this->db->select('COUNT(*) AS totalResults');
        $this->db->from($this->_table);
        $query = $this->db->get();
        $result = $query->result_array();
        if ($result) {
            return $result[0]['totalResults'];
        } else {
            return 0;
        }
    }

    public function cmsGetPagination($record, $start, $name = null)
    {
        $this->db->select($this->_table . '.*, u1.full_name AS singer_name,
        track_user.name AS singer_name2, tracks.title AS name_song,
        GROUP_CONCAT(track_user.`name` SEPARATOR ",") AS all_name, tracks.art AS art, tracks.art_type AS art_type');
        $this->db->from($this->_table);
        $this->db->join('track_user', 'track_user.track_id = ' . $this->_table . '.track_id', 'left');
        $this->db->join('tracks', 'tracks.id = ' . $this->_table . '.track_id', 'left');
        $this->db->join('users u1', 'u1.id = track_user.user_id', 'left');
        if($name != null) {  
            $data = explode('-', $name);  
            $this->db->where('month', $data[0]);
            $this->db->where('year', $data[1]);
        }
        $this->db->group_by($this->_table . '.id');
        $this->db->order_by($this->_table . '.total_point', 'desc');
        $this->db->limit($record);
        $query = $this->db->get();

        return $query->result_array();
    }

    public function selectSearch()
    {
        $this->db->select('month, year');
        $this->db->from($this->_table);
        $this->db->distinct($this->_table . '.month');
        $this->db->order_by( $this->_table . '.year desc');
        $this->db->order_by( $this->_table . '.month desc');
        $query = $this->db->get();

        return $query->result_array();
    }

    /**
     * Hàm lấy xếp hạng tháng trước để so sánh tăng/giảm hạng
     *
     * @param $month_year
     * @return array
     */
    public function previousRanking($month_year)
    {
        $this->db->select('track_id, order, month, year');
        $this->db->from($this->_table);

        if ($month_year != null) {
            $data = explode('-', $month_year);
            $month = intval($data[0]);
            $year = intval($data[1]);

            if ($month == 1) {
                $month = 12;
                $year = $year - 1;
            } else {
                $month = $month - 1;
            }

            $this->db->where('month', $month);
            $this->db->where('year', $year);
        }
        $this->db->where('order <=', 100);
        $query = $this->db->get();
        $data = $query->result_array();

        $result = [];
        if ($data) {
            foreach ($data as $key => $val) {
                $result[$val['track_id']] = $val['order'];
            }
        }

        return $result;
    }
}